package main

import (
	"fmt"
	"regexp"
	"strings"
)

func main() {
	// 正则开头匹配
	pattern := "^135"
	fmt.Println(regexp.MatchString(pattern, "1352359110x")) // true <nil>
	fmt.Println(regexp.MatchString(pattern, "139499xxx"))   // false <nil>
	fmt.Println(strings.HasPrefix("1352359110x", "135"))    // true

	// 手机号检测
	//pattern = "^135[0-9]{8}$"
	pattern = "^135\\d{8}$"
	fmt.Println(regexp.MatchString(pattern, "13523591100")) // true <nil>

	//pattern = "^13[5|9]\\d{8}$"
	//pattern = "^13[59]\\d{8}$"
	//pattern = "^(135|139)\\d{8}$"
	//pattern = "^(135)|(139)\\d{8}$"
	pattern = "^(135)|(139)[0-9]{8}$"
	fmt.Println(regexp.MatchString(pattern, "13523591100")) // true <nil>
	fmt.Println(regexp.MatchString(pattern, "13949912345")) // true <nil>

	// 邮箱检测
	//pattern = "[0-9a-zA-Z]{2,64}@[a-z0-9]{1,64}\\.(cn|com|net)$"
	pattern = "[0-9a-zA-Z]{2,64}@[a-z0-9]{1,64}[.](cn|com|net)$"
	fmt.Println(regexp.MatchString(pattern, "me@xiexianbin.cn")) // true <nil>

	// 原始字符串
	fmt.Println(regexp.QuoteMeta(`Escaping symbols like: .+*?()|[]{}^$`)) // Escaping symbols like: \.\+\*\?\(\)\|\[\]\{\}\^\$
	fmt.Println(regexp.MatchString(regexp.QuoteMeta("^a"), "^abcd"))
}
